VERSION 5.00
Object = "{648A5603-2C6E-101B-82B6-000000000014}#1.1#0"; "MSCOMM32.OCX"
Begin VB.Form KELLERFRM 
   Caption         =   "Keller-Demo"
   ClientHeight    =   3675
   ClientLeft      =   1125
   ClientTop       =   870
   ClientWidth     =   4770
   ScaleHeight     =   3675
   ScaleWidth      =   4770
   StartUpPosition =   2  'Bildschirmmitte
   Begin VB.ComboBox Combo2 
      Height          =   315
      ItemData        =   "KELLERFRM.frx":0000
      Left            =   3720
      List            =   "KELLERFRM.frx":0016
      Style           =   2  'Dropdown-Liste
      TabIndex        =   12
      Top             =   120
      Width           =   855
   End
   Begin VB.TextBox Text4 
      Height          =   285
      Left            =   1080
      TabIndex        =   10
      Top             =   3120
      Width           =   1695
   End
   Begin VB.ComboBox Combo1 
      Height          =   315
      ItemData        =   "KELLERFRM.frx":003E
      Left            =   1080
      List            =   "KELLERFRM.frx":004E
      Style           =   2  'Dropdown-Liste
      TabIndex        =   9
      Top             =   120
      Width           =   1095
   End
   Begin VB.TextBox Text3 
      Height          =   285
      Left            =   1080
      TabIndex        =   5
      Top             =   2640
      Width           =   1695
   End
   Begin VB.TextBox Text2 
      Height          =   765
      Left            =   1080
      MultiLine       =   -1  'True
      TabIndex        =   4
      Top             =   1680
      Width           =   3495
   End
   Begin VB.TextBox Text1 
      Height          =   885
      Left            =   1080
      MultiLine       =   -1  'True
      TabIndex        =   3
      Top             =   720
      Width           =   3495
   End
   Begin VB.CommandButton STOPCMD 
      Caption         =   "Close"
      Height          =   375
      Left            =   3480
      TabIndex        =   2
      Top             =   3120
      Width           =   1095
   End
   Begin VB.CommandButton INITCMD 
      Caption         =   "Init"
      Height          =   375
      Left            =   3480
      TabIndex        =   1
      Top             =   2640
      Width           =   1095
   End
   Begin MSCommLib.MSComm Comm1 
      Left            =   120
      Top             =   960
      _ExtentX        =   1005
      _ExtentY        =   1005
      _Version        =   393216
      DTREnable       =   -1  'True
   End
   Begin VB.Label Label6 
      Caption         =   "Channel to read"
      Height          =   255
      Left            =   2400
      TabIndex        =   13
      Top             =   120
      Width           =   1335
   End
   Begin VB.Label Label5 
      Caption         =   "Value"
      Height          =   255
      Left            =   120
      TabIndex        =   11
      Top             =   3120
      Width           =   735
   End
   Begin VB.Label Label4 
      Caption         =   "Port Nr."
      Height          =   255
      Left            =   120
      TabIndex        =   8
      Top             =   120
      Width           =   855
   End
   Begin VB.Label Label3 
      Caption         =   "ID:Version"
      Height          =   255
      Left            =   120
      TabIndex        =   7
      Top             =   2640
      Width           =   855
   End
   Begin VB.Label Label2 
      Caption         =   "Input"
      Height          =   255
      Left            =   120
      TabIndex        =   6
      Top             =   1680
      Width           =   615
   End
   Begin VB.Label Label1 
      Caption         =   "Output"
      Height          =   255
      Left            =   120
      TabIndex        =   0
      Top             =   720
      Width           =   615
   End
End
Attribute VB_Name = "KELLERFRM"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Sub Form_Load()
' initialisation of form-components
Combo1.ListIndex = 0
Combo2.ListIndex = 1
End Sub
Private Sub INITCMD_Click()

' Open communications port
Call OpenComms

Call PAUSE(0.1)

Text1.Text = ""
Text2.Text = ""
Text3.Text = ""
Text4.Text = ""

' Send full command string to communications port
' First Time for wakeup the device
Call F48
' give time to device
PAUSE (0.5)

' initialise after wakeup
Call F48
' read value
Call F73(Combo2.ListIndex)

' Close communications port
Call CloseComms

End Sub

Private Sub STOPCMD_Click()
' Close communications port if already open
Call CloseComms
Unload Me
End Sub

Sub F48()

Dim bTemp(20) As Byte
Dim str As String
Dim v As Variant
Dim i

' Load  command array
bTemp(0) = 250
bTemp(1) = 48

' Bytes Amount from Bus-Protocol: (F48)
' Request:
' DEV.ADDR  48  CRC16H  CRC16L
' 1         2   3       4         -> 4-2=2

' Response:
' DEV.ADDR  48     CLASS  GROUP  YEAR  WEEK  BUF   STAT  CRC16H  CRC16L
' 1(5)      2(6)   3(7)   4(8)   5(9)  6(10) 7(11) 8(12) 9(13)   10 (14)  -> 10-2=8

' call communication-routine
Call Transmit(bTemp, 2, 8, str)

If Len(str) >= 14 Then
  ' format answer-string to byte-array
  ReDim bArr(2 + 8 + 2 + 2) ' = 14
  For i = 0 To 14 - 1
     v = Mid(str, i + 1, 1)
     bArr(i) = CByte(Asc(v))
  Next i

  ' show the desired bytes
  Text3.Text = bArr(6) & "." & bArr(7) & " : " & bArr(8) & "." & bArr(9)
End If
  
End Sub

Sub F73(ByVal bCh As Byte)

Dim bTemp(20) As Byte
Dim bVal(3) As Byte
Dim str As String
Dim v As Variant
Dim i
Dim Val As Single

Dim l As Long

' Load  command array
bTemp(0) = 250
bTemp(1) = 73
bTemp(2) = bCh

l = bTemp()

' Bytes Amount from Bus-Protocoll: (F73)
' Request:
' DEV.ADDR  73  CH  CRC16H  CRC16L
' 1         2   3   4       5             -> 5-2 = 3

' Response:

' DEV.ADDR  73   EXP  M0   M1    M2    STAT  CRC16H  CRC16L
' 1(6)      2(7) 3(8) 4(9) 5(10) 6(11) 7(12) 8(13)   9(14)      -> 9-2 = 7

' call communication-routine
Call Transmit(bTemp, 3, 7, str)

If Len(str) >= 14 Then
  ' format answer-string to byte-array
  ReDim bArr(3 + 7 + 2 + 2) ' = 14
  For i = 0 To 14 - 1
     v = Mid(str, i + 1, 1)
     bArr(i) = CByte(Asc(v))
  Next i
  
  For i = 0 To 3
    bVal(i) = bArr(i + 7)
  Next i

  Val = GetSingle(bVal)
  ' show the value
  Text4.Text = Val
End If

End Sub

Sub Transmit(wArr, ByVal w, r As Byte, str As String)

Dim bArr() As Byte
Dim i, S, CRCNOW
Dim Nin, Nout
Dim try
Dim v As Variant
Dim c1, c2 As Byte

' amount of send-bytes = Amount send-bytes + CRC(2 Bytes)
Nout = w + 2
' amount of receive-bytes = Amount sent-bytes + receive-bytes + CRC(2) + CRC(2)
Nin = r + w + 2 + 2
ReDim bArr(Nout - 1)
For i = 0 To Nout - 1
bArr(i) = wArr(i)
Next i

' calculate CRC-sum and append to array
CRCNOW = CalcCrc16(bArr, Nout - 2)
bArr(w + 0) = Asc(Mid(CRCNOW, 1, 1))
bArr(w + 1) = Asc(Mid(CRCNOW, 2, 1))

' Display full command string
S = ""
For i = 0 To Nout - 1
    S = S & " " & CStr(bArr(i))
Next
S = Trim(S)
Text1.Text = Text1.Text + S + vbCrLf

' clear Input-Buffer
Comm1.InBufferCount = 0
' Send full command string to communications port
Comm1.Output = bArr
Call PAUSE(0.2)

' Receive response (4 trials)
try = 0
While (Comm1.InBufferCount < Nin) And (try < 4)
  Call PAUSE(0.2)
  try = try + 1
Wend

If Comm1.InBufferCount >= Nin Then
  str = Comm1.Input
End If

' check CRC of answer
If Len(str) >= Nin Then
  ReDim bArr(Nin)
  For i = Nout To Nin - 1
  v = Mid(str, i + 1, 1)
     bArr(i - Nout) = CByte(Asc(v))
  Next i
  
  For i = 0 To r + 2 - 1
    Text2.Text = Text2.Text & (bArr(i)) & " "
  Next
  Text2.Text = Text2.Text & vbCrLf
  
  CRCNOW = CalcCrc16(bArr, r)
  c1 = Asc(Mid(CRCNOW, 1, 1))
  c2 = Asc(Mid(CRCNOW, 2, 1))
   
  If (c1 <> bArr(r)) Or (c2 <> bArr(r + 1)) Then
    MsgBox "CRC-Sum is not correct"
  End If
  
End If

End Sub

Sub OpenComms()

Comm1.CommPort = Combo1.ListIndex + 1
Comm1.Settings = "9600,N,8,1"
' Comm1.InputMode = comInputModeBinary
' Comm1.InputMode = comInputModeText
Comm1.PortOpen = True
Comm1.InBufferCount = 0
End Sub

Sub CloseComms()

If Comm1.PortOpen Then
  Comm1.PortOpen = False
End If
End Sub

Function CalcCrc16(Datain, Nin)

Dim HA001, HFF, CRC, i, L1, N, S1, S2

HA001 = 40961
HFF = 255
CRC = 65535
If Nin > 0 Then
    For i = 0 To Nin - 1
        L1 = Datain(i)
        CRC = CRC Xor L1
        For N = 1 To 8
            If (CRC Mod 2) = 1 Then
                CRC = CRC \ 2
                CRC = CRC Xor HA001
            Else
                CRC = CRC \ 2
            End If
        Next
    Next
End If
S2 = CRC And HFF
S1 = (CRC \ (2 ^ 8)) And HFF
CalcCrc16 = Chr(S1) & Chr(S2)
End Function
Function pow(ByVal exp As Double) As Double
  
Dim i As Integer
Dim b As Double

b = 1
For i = 0 To Abs(exp)
  b = b * 2
Next i
b = b / 2

If exp < 0 Then
  b = 1 / b
End If

pow = b
End Function
' function to calculate IEEE754-Single Type from 4 Byte-Array
Function GetSingle(bArr) As Single

Dim b0, b1, b2, b3 As Byte
Dim i
Dim a, hbm, exponent As Single

b0 = bArr(3)
b1 = bArr(2)
b2 = bArr(1)
b3 = bArr(0)

b3 = b3

For i = 0 To 7
  If b0 And CByte(pow(i)) Then
    hbm = hbm + CSng(pow(-(23 - i)))
  End If
Next i

For i = 0 To 7
  If b1 And CByte(pow(i)) Then
    hbm = hbm + CSng(pow(-(15 - i)))
  End If
Next i

For i = 0 To 6
  If b2 And CByte(pow(i)) Then
    hbm = hbm + CSng(pow(-(7 - i)))
  End If
Next i

hbm = hbm + 1

If b2 And 128 Then
  exponent = exponent + 1
End If

For i = 0 To 6
  If b3 And CByte(pow(i)) Then
    exponent = exponent + CSng(pow(i + 1))
  End If
Next i

exponent = exponent - 127

a = hbm * CSng(pow(CDbl(exponent)))

If b3 And 128 Then
  a = a * -1
End If

GetSingle = a

End Function

Public Sub PAUSE(ByVal nSecond)

Dim t0

t0 = Timer
Do While Timer - t0 < nSecond
  Dim DUMMY
  If Timer < t0 Then
    t0 = t0 - 24 * 60 * 60
  End If
Loop
End Sub
