VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Readout pressure 23.10.09"
   ClientHeight    =   2565
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   3915
   LinkTopic       =   "Form1"
   ScaleHeight     =   2565
   ScaleWidth      =   3915
   StartUpPosition =   1  'Fenstermitte
   Begin VB.CheckBox CheckEcho 
      Caption         =   "Echo ON"
      Height          =   255
      Left            =   2760
      TabIndex        =   10
      Top             =   360
      Value           =   1  'Aktiviert
      Width           =   1095
   End
   Begin VB.TextBox ComPortN 
      Alignment       =   1  'Rechts
      BeginProperty DataFormat 
         Type            =   1
         Format          =   "0"
         HaveTrueFalseNull=   0
         FirstDayOfWeek  =   0
         FirstWeekOfYear =   0
         LCID            =   1031
         SubFormatType   =   1
      EndProperty
      Height          =   285
      Left            =   1320
      TabIndex        =   9
      Text            =   "1"
      ToolTipText     =   "Select Comport-Number"
      Top             =   330
      Width           =   495
   End
   Begin VB.TextBox TextComstate 
      BackColor       =   &H80000004&
      Height          =   285
      Left            =   1080
      Locked          =   -1  'True
      TabIndex        =   6
      Text            =   "Com closed"
      Top             =   2130
      Width           =   2655
   End
   Begin VB.Timer Timer1 
      Left            =   2280
      Top             =   240
   End
   Begin VB.TextBox TextP1 
      Alignment       =   1  'Rechts
      BeginProperty DataFormat 
         Type            =   1
         Format          =   "0,0"
         HaveTrueFalseNull=   0
         FirstDayOfWeek  =   0
         FirstWeekOfYear =   0
         LCID            =   1031
         SubFormatType   =   1
      EndProperty
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   12
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   405
      Left            =   1320
      TabIndex        =   5
      ToolTipText     =   "Actual Pressure in the Device"
      Top             =   840
      Width           =   1215
   End
   Begin VB.TextBox TextT 
      Alignment       =   1  'Rechts
      BeginProperty DataFormat 
         Type            =   1
         Format          =   "0,0"
         HaveTrueFalseNull=   0
         FirstDayOfWeek  =   0
         FirstWeekOfYear =   0
         LCID            =   1031
         SubFormatType   =   1
      EndProperty
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   12
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   405
      Left            =   1320
      TabIndex        =   3
      ToolTipText     =   "Pmax - Pmin until Start"
      Top             =   1320
      Width           =   1215
   End
   Begin VB.CommandButton CommandStop 
      Caption         =   "Stop"
      Enabled         =   0   'False
      Height          =   375
      Left            =   2760
      TabIndex        =   1
      Top             =   1320
      Width           =   975
   End
   Begin VB.CommandButton CommandStart 
      Caption         =   "Start"
      Height          =   375
      Left            =   2760
      TabIndex        =   0
      Top             =   840
      Width           =   975
   End
   Begin VB.Label Label11 
      Caption         =   "ComPort-N :"
      Height          =   255
      Left            =   240
      TabIndex        =   8
      Top             =   360
      Width           =   975
   End
   Begin VB.Label Label6 
      Caption         =   "Status :"
      Height          =   255
      Left            =   240
      TabIndex        =   7
      Top             =   2160
      Width           =   855
   End
   Begin VB.Label Label5 
      Caption         =   "Druck [bar] :"
      Height          =   255
      Left            =   240
      TabIndex        =   4
      Top             =   840
      Width           =   1095
   End
   Begin VB.Label Label4 
      Caption         =   "Temperatur [C]:"
      Height          =   255
      Left            =   0
      TabIndex        =   2
      Top             =   1320
      Width           =   1215
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Dim Status As Integer
Dim Comport As Integer
Const Adresse = 250
Const WaitTime = 0.001

Private Sub CommandStart_Click()
  ComPortN.SetFocus
  CommandStart.Enabled = False
  CommandStop.Enabled = True
  Comport = ComPortN.Text
  If ((Comport < 1) Or (Comport > 50)) Then
        ComPortN.Text = 1
  End If
  Timedelay (WaitTime)
  Status = OpenComPort(Comport, 100)
  EchoOn (CheckEcho.Value)
  If Status Then
        Beep
        TextComstate.Text = "Kann Comport nicht ffnen !!!"
        Call CommandStop_Click
        MsgBox "Can't open Comport!"
  Else
    Timer1.Interval = 500  ' Init Starten
    Timer1.Enabled = True
    TextComstate.Text = "Bin am Initialisieren...."
    initdevice (Adresse)
  End If
End Sub

Private Sub CommandStop_Click()
    ' Comport schliessen
    Timer1.Enabled = False
    TextComstate.Text = "Programm stoped.."
    Status = CloseComPort()
    CommandStart.Enabled = True
    CommandStop.Enabled = False
End Sub


Private Sub Form_Unload(Cancel As Integer)
    Call CommandStop_Click
End Sub

Private Sub Timer1_Timer()
Dim Stat As Variant
   
   Timedelay (WaitTime)
   TextComstate.Text = "Read out P1 and TOB1..."
   Status = F73(Adresse, 1, Value, Stat)
   If (Status) Then
        Call Error
   Else
        TextP1.Text = Value
        Timedelay (WaitTime)
        Status = F73(Adresse, 4, Value, Stat)
        If (Status) Then
              Call Error
        End If
        TextT.Text = Value
    End If
End Sub

Function initdevice(ByVal Nummer As Integer) As Integer
' Transmitter initialisieren und Transmitterdaten lesen
    Dim CClass, CGroup, CYear, CWeek, CBuffer, CState As Byte
    
    Timedelay (WaitTime)
    initdevice = F48(Nummer, CClass, CGroup, CYear, CWeek, CBuffer, CState)
    'initdevice = 0
End Function

Sub Timedelay(ByVal Pausenlaenge As Variant) ' in ms
Dim Start, Ende, Gesamtdauer

    Start = Timer    ' Anfangszeit setzen.
    Do While Timer < Start + Pausenlaenge
        DoEvents    ' Steuerung an andere Prozesse
    Loop
End Sub

Sub Error()
    Beep
    Call CommandStop_Click
    TextComstate.Text = "Communication Error !"
End Sub
