Attribute VB_Name = "S30c_dll"
'-------------------- Beispielprogramm ------------------------------------------------------------
'
'Einfaches Programm-Beispiel zur Kommunikation mit Transmitter der Serie 30 oder Manometer LEO
'mit Verwendung der S30c.dll.
'-----------------------------------------------------------------------------------------------
'KELLER AG fr Druckmesstechnik Winterthur   M.Gautschi   28.11.00
'
'Bemerkungen:
'
'- Dieses Beispielprogramm ffnet den Comport, initialisiert den Transmitter
'  und liest den aktuellen Druck aus.
'  Das Programm enthlt nur die wichtigsten Programmteile zum ansprechen
'  eines Transmitters (Serie 30) oder eines Manometers (LEO).
'
'- Die Datei S30c.dll muss entweder ins Verzeichnis "C:\windows\system" kopiert werden oder
'  der Pfad der Datei muss in der Funktions-Deklaration angegeben werden.
'  Bsp: Declare Function OpenCommPort Lib "c:\demo\S30c.dll" (ByVal Port As Integer) As Integer
'
'- Es ist zwingend notwendig, vor Ende des Programms den benutzten seriellen Port mit der
'  Funktion CloseCommPort wieder freizugeben
'
'-----------------------------------------------------------------------------------------------'
'
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'S30c.dll einbinden
''
Declare Function OpenComPort Lib "S30c.dll" (ByVal Port As Integer, ByVal Timeout As Integer) As Integer
Declare Function CloseComPort Lib "S30c.dll" () As Integer
Declare Function F48 Lib "S30c.dll" (ByVal DevAddr As Byte, ByRef Class As Byte, ByRef Group As Byte, ByRef Year As Byte, ByRef Week As Byte, ByRef Buffer As Byte, ByRef State As Byte) As Integer
Declare Function F73 Lib "S30c.dll" (ByVal DevAddr As Byte, ByVal Kanal As Byte, ByRef PresVal As Single, ByRef State As Byte) As Integer
Declare Function F95 Lib "S30c.dll" (ByVal DevAddr As Byte, ByVal CMD As Byte) As Integer
Declare Function EchoOn Lib "S30c.dll" (ByVal bEcho As Boolean) As Integer

''
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' DLL - Fehler
Const OK = 0
Const BUSY = 0
Const Timeout = -102
Const EXCEPTION1 = -1
Const EXCEPTION2 = -2
Const EXCEPTION3 = -3
Const EXCEPTION32 = -32
Const ERRROR = -100
Const UART_ERROR = -101
Const TIME_OUT = -102
Const BAD_DATA = -103
'
'


